//genMethods "-g" "-t" "Vertex" "-I" "LINK/graph/Vertex.h" "-d" "graph" "-y" "display_vertex" "-w" "free_vertex" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>
#include <LINK/graph/Vertex.h>
#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
void display_vertex(SCM, SCM, int);
void free_vertex(SCM);
typedef Vertex _Vertex;
#define _VertexDATA(x) ((Vertex*) (EXTDATA(x)))
#define _VertexIS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Vertex >::type))
#define _VertexISNT_DATA(x) (!IS_DATA(x))
#define _VertexCXX_DATA(x) (*(Vertex*) (EXTDATA(VAL(x))))
#define _VertexCXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Vertex >::type))
#define _VertexCXX_ISNT_DATA(x) (!CXX_IS_DATA(x))
#include <strstream.h>
void display_vertex(SCM c, SCM port, int mode)
{
        ostrstream oss;
	if (_VertexDATA(c))
        	oss << *_VertexDATA(c);
        oss << ends;
        char *buffer = oss.str();
        Puts(buffer, (port));
        delete buffer;
}
void free_vertex(SCM p)
{
        if (!EXTSTATICP(p))
                Register<Vertex>::deleteEntry(_VertexDATA(p));
}
// define your new methods above 
// and register them using STk_add_new_cpp_primitive() below
void genExtra_VertexMethods() {}
